﻿#region License Information
/* HeuristicLab
 * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Parameters;
using HEAL.Attic;
using HeuristicLab.Problems.VehicleRouting.Interfaces;

namespace HeuristicLab.Problems.VehicleRouting.Encodings.General {
  [Item("VRPCreator", "Creates a VRP solution.")]
  [StorableType("E37923DB-8BA5-4FE3-956D-3D65AA18037C")]
  public abstract class VRPCreator : VRPOperator, IVRPCreator {
    public ILookupParameter<IVRPEncodedSolution> VRPToursParameter {
      get { return (ILookupParameter<IVRPEncodedSolution>)Parameters["VRPTours"]; }
    }

    [StorableConstructor]
    protected VRPCreator(StorableConstructorFlag _) : base(_) { }

    public VRPCreator()
      : base() {
      Parameters.Add(new LookupParameter<IVRPEncodedSolution>("VRPTours", "The VRP tours to be created."));
    }

    protected VRPCreator(VRPCreator original, Cloner cloner)
      : base(original, cloner) {
    }
  }
}
